// $Id: EODataSource.m,v 1.2 2002/11/17 17:29:11 helge Exp $

#include <EOControl/EODataSource.h>
#include <EOControl/EOClassDescription.h>
#include "common.h"

@implementation EODataSource

+ (int)version {
  return 1;
}

/* reflection */

- (EOClassDescription *)classDescriptionForObjects {
  return nil;
}

/* master-detail */

- (EODataSource *)dataSourceQualifiedByKey:(NSString *)_relKey {
  [NSException raise:@"NSInvalidArgumentException"
               format:@"datasource %@ can't return a ds qualified by key '%@'",
                 self, _relKey];
  return nil;
}

- (void)qualifyWithRelationshipKey:(NSString *)_relKey ofObject:(id)_object {
  [NSException raise:@"NSInvalidArgumentException"
               format:@"datasource %@ can't qualify by key '%@' of object %@",
                 self, _relKey, _object];
}

/* operations */

- (NSArray *)fetchObjects {
  return nil;
}
- (NSEnumerator *)fetchEnumerator {
  return [[self fetchObjects] objectEnumerator];
}

- (void)deleteObject:(id)_object {
  [NSException raise:@"NSInvalidArgumentException"
               format:@"datasource %@ can't delete object %@",
                 self, _object];
}

- (void)insertObject:(id)_object {
  [NSException raise:@"NSInvalidArgumentException"
               format:@"datasource %@ can't insert object %@",
                 self, _object];
}

- (id)createObject {
  EOClassDescription *cd;
  
  if ((cd = [self classDescriptionForObjects]) == nil)
    return nil;
  
  return [cd createInstanceWithEditingContext:nil globalID:nil zone:NULL];
}

@end /* EODataSource */
