// $Id: EOFetchSpecification.h,v 1.2 2002/10/30 12:37:32 helge Exp $

#ifndef __EOFetchSpecification_h__
#define __EOFetchSpecification_h__

#import <Foundation/NSObject.h>

@class NSArray, NSString, NSDictionary;
@class EOQualifier;

@interface EOFetchSpecification : NSObject < NSCopying >
{
  NSString     *entityName;
  EOQualifier  *qualifier;
  NSArray      *sortOrderings;
  BOOL         usesDistinct;
  BOOL         locksObjects;
  unsigned     fetchLimit;
  NSDictionary *hints;
}

+ (EOFetchSpecification *)fetchSpecificationWithEntityName:(NSString *)_ename
  qualifier:(EOQualifier *)_qualifier
  sortOrderings:(NSArray *)sortOrderings;

- (id)initWithEntityName:(NSString *)_name
  qualifier:(EOQualifier *)_qualifier
  sortOrderings:(NSArray *)_sortOrderings
  usesDistinct:(BOOL)_dflag;

/* plist initializers */

- (id)initWithDictionary:(NSDictionary *)_dictionary;
- (id)initWithString:(NSString *)_string;
- (id)initWithPropertyList:(id)_plist;

/* accessors */

- (void)setEntityName:(NSString *)_name;
- (NSString *)entityName;

- (void)setQualifier:(EOQualifier *)_qualifier;
- (EOQualifier *)qualifier;

- (void)setSortOrderings:(NSArray *)_orderings;
- (NSArray *)sortOrderings;

- (void)setUsesDistinct:(BOOL)_flag;
- (BOOL)usesDistinct;

- (void)setLocksObjects:(BOOL)_flag;
- (BOOL)locksObjects;

- (void)setFetchLimit:(unsigned)_limit;
- (unsigned)fetchLimit;

- (void)setHints:(NSDictionary *)_hints;
- (NSDictionary *)hints;

/* bindings */

- (EOFetchSpecification *)fetchSpecificationWithQualifierBindings:(NSDictionary *)_bindings;

/* remapping keys */

- (EOFetchSpecification *)fetchSpecificationByApplyingKeyMap:(NSDictionary *)_m;

@end

#endif /* __EOFetchSpecification_h__ */
