// $Id: EOGenericRecord.h,v 1.1.1.1 2002/05/22 17:27:33 helge Exp $

#ifndef __EOControl_EOGenericRecord_h__
#define __EOControl_EOGenericRecord_h__

#import <Foundation/NSObject.h>
#import <Foundation/NSMapTable.h>
#include <EOControl/EOGlobalID.h>

@class NSDictionary, NSArray, NSString, NSEnumerator;
@class EOClassDescription;

/*
 * EOGeneric record class, used for enterprise objects
 * that do not have special data handling
 */

@interface EOGenericRecord : NSObject < NSCopying >
{
  EOClassDescription *classDescription;
  IMP                willChange;

  /* hash-table */
  struct _NSMapNode  **nodes;
  unsigned int       hashSize;
  unsigned int       itemsCount;
}

- (id)initWithEditingContext:(id)_ec
  classDescription:(EOClassDescription *)_classDesc
  globalID:(EOGlobalID *)_oid;

// Key-value coding methods

- (void)takeValuesFromDictionary:(NSDictionary *)dictionary;
- (NSDictionary *)valuesForKeys:(NSArray *)keys;

// Shortcuts to key-value coding methods

- (void)setObject:(id)anObject forKey:(id)aKey;
- (id)objectForKey:(id)aKey;
- (void)removeObjectForKey:(id)aKey;

@end /* EOGenericRecord */


@class NSEnumerator;

@interface EOGenericRecord(EOMOF2Extensions)
- (NSEnumerator *)keyEnumerator;
@end

#endif /* __EOControl_EOGenericRecord_h__ */
