// $Id: EOKeyGlobalID.h,v 1.1.1.1 2002/05/22 17:27:37 helge Exp $

#ifndef __EOControl_EOKeyGlobalID_H__
#define __EOControl_EOKeyGlobalID_H__

#include <EOControl/EOGlobalID.h>

@class NSArray;

/*
  An immutable global id based on primary key values. The values must
  be passed in the alphabetical order of the attribute named.

  This class cannot be subclassed !!!
*/

@interface EOKeyGlobalID : EOGlobalID < NSCoding >
{
@protected
  NSString     *entityName;
  unsigned int count;
  id           values[1];
}

+ (id)globalIDWithEntityName:(NSString *)_name
  keys:(id *)_keyValues
  keyCount:(unsigned int)_count
  zone:(NSZone *)_zone;

/* accessors */

- (NSString *)entityName;
- (unsigned int)keyCount;
- (id *)keyValues;
- (NSArray *)keyValuesArray;

@end

#endif /* __EOControl_EOKeyGlobalID_H__ */
