// $Id: EONull.m,v 1.1.1.1 2002/05/22 17:27:31 helge Exp $

#include "EONull.h"
#include "common.h"

#ifdef EONull
#  undef EONull
#endif

@interface EONull : NSNull
@end

@implementation EONull

+ (id)allocWithZone:(NSZone *)_zone {
  return [NSNull allocWithZone:_zone];
}

+ (id)null {
  return [NSNull null];
}

- (id)self {
  return [NSNull null];
}

@end

@implementation NSNull(ExprValue)

- (BOOL)boolValue {
  return NO;
}

- (NSString *)expressionValueForContext:(id)context {
  /* context is really EOExpressionArray .. */
  return @"NULL";
}

@end /* EONull(ExprValue) */
