// $Id: NSArray+EOQualifier.m,v 1.2 2003/01/07 11:30:31 helge Exp $

#include <EOControl/EOQualifier.h>
#include "common.h"

@implementation NSArray(EOQualifier)

- (NSArray *)filteredArrayUsingQualifier:(EOQualifier *)_qualifier {
  NSAutoreleasePool *pool;
  NSMutableArray *array = nil;
  NSArray  *result;
  unsigned i, count;

  pool = [[NSAutoreleasePool alloc] init];
  result = nil;
  
  count = [self count];
  array = [NSMutableArray arrayWithCapacity:count];
  for (i = 0, count; i < count; i++) {
    id o;
    
    o = [self objectAtIndex:i];
    
    if ([(id<EOQualifierEvaluation>)_qualifier evaluateWithObject:o])
      [array addObject:o];
  }
  result = [array copy];
  [pool release];
  return [result autorelease];
}

@end /* NSArray(EOQualifier) */
