// $Id: EODataSource+NGExtensions.m,v 1.3 2003/01/07 11:33:35 helge Exp $

#include "EODataSource+NGExtensions.h"
#include <EOControl/EOFetchSpecification.h>
#include "common.h"

NGExtensions_DECLARE NSString *EODataSourceDidChangeNotification =
  @"EODataSourceDidChangeNotification";
NGExtensions_DECLARE NSString *EONoFetchWithEmptyQualifierHint =
  @"EONoFetchWithEmptyQualifierHint";

@implementation EODataSource(NGExtensions)

- (void)setFetchSpecification:(EOFetchSpecification *)_fetchSpec {
  [self doesNotRecognizeSelector:_cmd];
}

- (EOFetchSpecification *)fetchSpecification {
  [self doesNotRecognizeSelector:_cmd];
  return nil;
}
- (void)updateObject:(id)_obj {
  [self doesNotRecognizeSelector:_cmd];
}

- (void)postDataSourceChangedNotification {
  static NSNotificationCenter *nc = nil;
  
  if (nc == nil)
    nc = [[NSNotificationCenter defaultCenter] retain];
  
  [nc postNotificationName:EODataSourceDidChangeNotification object:self];
}


@end /* EODataSource(NGExtensions) */

/* static linking */

void __link_EODataSource_NGExtensions(void) {
  __link_EODataSource_NGExtensions();
}
