// $Id: EOGroupingSet.m,v 1.2 2003/01/07 11:33:35 helge Exp $

#include <NGExtensions/EOGroupingSet.h>
#include "common.h"

@interface EOGroupingSet(PrivateMethodes)
- (void)_updateDefaultNames;
@end


@implementation EOGroupingSet

- (void)dealloc {
  [self->groupings release];
  [super dealloc];
}

- (void)setGroupings:(NSArray *)_groupings {
  ASSIGN(self->groupings, _groupings);
  [self _updateDefaultNames];
}
- (NSArray *)groupings {
  return self->groupings;
}

- (void)setDefaultName:(NSString *)_defaultName {
  [super setDefaultName:_defaultName];
  [self _updateDefaultNames];
}

- (NSString *)groupNameForObject:(id)_object {
  NSString *result;
  int      i, cnt;

  for (i = 0, cnt = [self->groupings count]; i < cnt; i++) {
    EOGrouping *group;

    group = [self->groupings objectAtIndex:i];
    if ((result = [group groupNameForObject:_object]))
      return result;
  }
  return self->defaultName;
}

- (NSArray *)orderedGroupNames {
  NSMutableArray *result;
  unsigned int   i, cnt;

  result = [[NSMutableArray allocWithZone:[self zone]] initWithCapacity:8];
  
  for (i = 0, cnt = [self->groupings count]; i < cnt; i++) {
    EOGrouping *group;

    group = [self->groupings objectAtIndex:i];
    [result addObjectsFromArray:[group orderedGroupNames]];
  }
  
  return [result autorelease];
}

@end /* EOGroupingSet */

@implementation EOGroupingSet(PrivateMethodes)

- (void)_updateDefaultNames {
  unsigned int i, cnt;

  for (i = 0, cnt = [self->groupings count]; i < cnt; i++) {
    EOGrouping *group;

    group = [self->groupings objectAtIndex:i];
    [group setDefaultName:nil];
  }
}

@end /* EOGroupingSet(PrivateMethodes) */
