// $Id: EOKeyGrouping.m,v 1.2 2003/01/07 11:33:35 helge Exp $

#include <NGExtensions/EOKeyGrouping.h>
#include "common.h"

@implementation EOKeyGrouping

- (id)initWithKey:(NSString *)_key {
  if ((self = [super initWithDefaultName:nil])) {
    self->key        = [_key copy];
    self->groupNames = [[NSMutableArray alloc] initWithCapacity:32];
  }
  return self;
}

- (void)dealloc {
  [self->key        release];
  [self->groupNames release];
  [super dealloc];
}

// accessors

- (NSString *)key {
  return self->key;
}
- (void)setKey:(NSString *)_key {
  NSAssert1(_key != nil, @"%s: nil _key parameter", __PRETTY_FUNCTION__);
  ASSIGNCOPY(self->key, _key);
}

// -----------------------------------

- (NSString *)groupNameForObject:(id)_object {
  NSString *result = nil;

  if ([self->key length] == 0)
    return @"";
  
  result = [[_object valueForKey:self->key] stringValue];
  result = (result != nil) ? result : self->defaultName;
  
  if (result == nil)
    return nil;
  
  if (![self->groupNames containsObject:result])
    [self->groupNames addObject:result];
  
  return result;
}

- (NSArray *)orderedGroupNames {
  if ([self->key length] == 0)
    return [NSArray arrayWithObject:@""];
  
  return self->groupNames;
}

@end /* EOKeyGrouping */
