// $Id: EOQualifier+CtxEval.h,v 1.1.1.1 2002/05/22 17:27:16 helge Exp $

#ifndef __NGExtensions_EOQualifier_ContextEvaluation_H__
#define __NGExtensions_EOQualifier_ContextEvaluation_H__

#import <EOControl/EOQualifier.h>
#import <Foundation/NSArray.h>

@interface EOQualifier(ContextEvaluation)

- (BOOL)evaluateWithObject:(id)_object context:(id)_context;

@end

@interface NSArray(ContextEvaluation)

- (NSArray *)filteredArrayUsingQualifier:(EOQualifier *)_qualifier
  context:(id)_context;

@end

@interface NSObject(ContextQualifierComparisons)

- (BOOL)isEqualTo:(id)_object inContext:(id)_context;
- (BOOL)isNotEqualTo:(id)_object inContext:(id)_context;

- (BOOL)isLessThan:(id)_object inContext:(id)_context;
- (BOOL)isGreaterThan:(id)_object inContext:(id)_context;
- (BOOL)isLessThanOrEqualTo:(id)_object inContext:(id)_context;
- (BOOL)isGreaterThanOrEqualTo:(id)_object inContext:(id)_context;

- (BOOL)doesContain:(id)_object inContext:(id)_context;

- (BOOL)isLike:(NSString *)_object inContext:(id)_context;
- (BOOL)isCaseInsensitiveLike:(NSString *)_object inContext:(id)_context;

@end

#endif /* __NGExtensions_EOQualifier_ContextEvaluation_H__ */
