// $Id: EOQualifierGrouping.m,v 1.2 2003/01/07 11:33:35 helge Exp $

#include <NGExtensions/EOQualifierGrouping.h>
#include <EOControl/EOQualifier.h>
#include "common.h"

@implementation EOQualifierGrouping

- (id)initWithQualifier:(EOQualifier *)_qualifier name:(NSString *)_name {
  if ((self = [super initWithDefaultName:nil])) {
    self->name      = [_name copy];
    self->qualifier = [_qualifier retain];
  }
  return self;
}

- (void)dealloc {
  [self->qualifier release];
  [self->name      release];
  [super dealloc];
}

// accessors

- (void)setName:(NSString *)_name {
  NSAssert1(_name != nil, @"%s: name is nil", __PRETTY_FUNCTION__);
  ASSIGNCOPY(self->name, _name);
}
- (NSString *)name {
  return self->name;
}

- (void)setQualifier:(EOQualifier *)_qualifier {
  ASSIGN(self->qualifier, _qualifier);
}
- (EOQualifier *)qualifier {
  return self->qualifier;
}

// -----------------------------------

- (NSString *)groupNameForObject:(id)_object {
  if (self->qualifier == nil)
    return self->name;
  
  if ([(id<EOQualifierEvaluation>)self->qualifier evaluateWithObject:_object])
    return self->name;
  
  return self->defaultName;
}

- (NSArray *)orderedGroupNames {
  return [NSArray arrayWithObjects:[self name], [self defaultName], nil];
}

@end /* EOQualifierGrouping */
