/* 
   NGBaseTypes.h

   Copyright (C) 2002 SKYRIX Software AG, Helge Hess
   All rights reserved.

   Author: Helge Hess (helge.hess@skyrix.com)

   This file is part of the SKYRiX Core Framework

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/
// $Id: NGBaseTypes.h,v 1.2 2002/12/27 09:42:32 helge Exp $

#ifndef __NGExtensions_NGBaseTypes_H__
#define __NGExtensions_NGBaseTypes_H__

#import <Foundation/NSObject.h>
#import <Foundation/NSString.h>
#import <Foundation/NSValue.h>

static inline NSNumber *shortObj(short _s) {
  return [NSNumber numberWithShort:_s];
}

static inline NSNumber *intObj(int _i) {
  return [NSNumber numberWithInt:_i];
}

static inline NSNumber *floatObj(float _f) {
  return [NSNumber numberWithFloat:_f];
}

static inline NSNumber *doubleObj(double _d) {
  return [NSNumber numberWithDouble:_d];
}

static inline NSString *cstrObj(const char *_c) {
  return [NSString stringWithCString:_c];
}

#endif /* __NGExtensions_NGBaseTypes_H__ */
