// $Id: NGDirectoryEnumerator.h,v 1.1.1.1 2002/05/22 17:27:16 helge Exp $

#ifndef __NGDirectoryEnumerator_H__
#define __NGDirectoryEnumerator_H__

#import <Foundation/NSEnumerator.h>
#include <NGExtensions/NGFileManager.h>

/*
  A class which is compatible to NSDirectoryEnumerator, but works with any
  object conforming to the filemanager interface.
*/

@class NSString, NSMutableArray, NSFileManager, NSDictionary;

@interface NGDirectoryEnumerator : NSEnumerator
{
  id<NSObject,NGFileManager> fileManager;

  NSMutableArray *enumStack;
  NSMutableArray *pathStack;
  NSString       *currentFileName;
  NSString       *currentFilePath;
  NSString       *topPath;
  struct {
    BOOL isRecursive:1;
    BOOL isFollowing:1;
  } flags;
}

- (id)initWithFileManager:(id<NSObject,NGFileManager>)_fm
  directoryPath:(NSString *)path 
  recurseIntoSubdirectories:(BOOL)recurse
  followSymlinks:(BOOL)follow
  prefixFiles:(BOOL)prefix;
- (id)initWithFileManager:(id<NSObject,NGFileManager>)_fm;
- (id)initWithFileManager:(id<NSObject,NGFileManager>)_fm
  directoryPath:(NSString *)_path;

- (id<NSObject,NGFileManager>)fileManager;

- (NSDictionary *)directoryAttributes;
- (NSDictionary *)fileAttributes;

- (void)skipDescendents;

@end

#endif /* __NGDirectoryEnumerator_H__ */
