// $Id: NGFileFolderInfoDataSource.h,v 1.1.1.1 2002/05/22 17:27:16 helge Exp $

#ifndef __NGFileInfoDataSource_H__
#define __NGFileInfoDataSource_H__

#import <Foundation/NSFileManager.h>
#import <EOControl/EODataSource.h>
#include <NGExtensions/NGExtensionsDecls.h>

@class NSString;
@class EOFetchSpecification;

/*
  supported keys:

    NSFileName
    NSFilePath
    NSParentPath
    + all NSFileManager attributes returned by -fileAttributesAtPath:...
    
  supported fetch hints:
  
    NSTraverseLinks - bool
*/

NGExtensions_EXPORT NSString *NSFileName;
NGExtensions_EXPORT NSString *NSFilePath;
NGExtensions_EXPORT NSString *NSParentPath;
NGExtensions_EXPORT NSString *NSTraverseLinks;

@interface NGFileFolderInfoDataSource : EODataSource
{
  NSString             *folderPath;
  EOFetchSpecification *fspec;
}

- (id)initWithFolderPath:(NSString *)_path;

/* accessors */

- (void)setFetchSpecification:(EOFetchSpecification *)_fspec;
- (EOFetchSpecification *)fetchSpecification;

/* operations */

- (NSArray *)fetchObjects;

@end

#endif /* __NGFileInfoDataSource_H__ */
