// $Id: NGFileManagerURL.h,v 1.1.1.1 2002/05/22 17:27:16 helge Exp $

#ifndef __NGFileManagerURL_H__
#define __NGFileManagerURL_H__

#if GNUSTEP_BASE_LIBRARY
#  import <Foundation/NSObjCRuntime.h> /* add GS_EXPORT .. */
#  import <Foundation/NSObject.h>      /* add NSObject .. */
#endif

#import <Foundation/NSURL.h>
#include <NGExtensions/NGFileManager.h>

/*
  A URL which works on NGFileManager's.
  
  The NSURLHandle should work, but the URL can't be serialized.
*/

@interface NGFileManagerURL : NSURL
{
  /* do *NOT* cache in filemanager - retain cycle !!! */
  id<NSObject,NGFileManager> fileManager;
  NSString *path;
}

- (id)initWithPath:(NSString *)_path
  fileManager:(id<NSObject,NGFileManager>)_fm;

/* accessors */

- (id<NSObject,NGFileManager>)fileManager;

@end

#endif /* __NGFileManagerURL_H__ */
