/* 
   NGMD5Generator.h

   Copyright (C) 2002 SKYRIX Software AG, Helge Hess
   All rights reserved.

   Author: Helge Hess (helge.hess@skyrix.com)

   This file is part of the SKYRiX Core Framework

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.

   This code is:
    "derived from the RSA Data Security, Inc. MD5 Message-Digest Algorithm"
*/
// $Id: NGMD5Generator.h,v 1.2 2002/12/27 09:42:33 helge Exp $

#ifndef __NGExtensions_NGMD5Generator_H__
#define __NGExtensions_NGMD5Generator_H__

#import <Foundation/NSObject.h>

@class NSString, NSData;

// MD5 encoding class

NSString *NGMD5DigestForString(NSString *_input);
NSString *NGMD5DigestForData(NSData *_input);

@interface NGMD5Generator : NSObject
{
@protected
  unsigned int  state[4];   // state (ABCD)
  unsigned int  count[2];   // number of bits, modulo 2^64 (lsb first)
  unsigned char buffer[64]; // input buffer
  unsigned char digest[16];
  BOOL hasDigest;
}

- (id)init;

// encoding

- (void)encodeString:(NSString *)_string;
- (void)encodeBytes:(const void *)_bytes count:(unsigned)_length;
- (void)encodeData:(NSData *)_data;

// digest

- (NSData *)digestAsData;
- (NSString *)digestAsString;

- (NSData *)xorDigestAsDataWithData:(NSData *)_data;

@end

#endif /* __NGExtensions_NGMD5Generator_H__ */
