/* 
   NGMemoryAllocation.h

   Copyright (C) 2002 SKYRIX Software AG, Helge Hess
   All rights reserved.

   Author: Helge Hess (helge.hess@skyrix.com)

   This file is part of the SKYRiX Core Framework

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/
// $Id: NGMemoryAllocation.h,v 1.2 2002/12/27 09:43:13 helge Exp $

#ifndef __NGExtensions_NGMemoryAllocation_H__
#define __NGExtensions_NGMemoryAllocation_H__

#include <objc/objc-api.h>
#include <stdlib.h>

#if LIB_FOUNDATION_BOEHM_GC
#  define NGMalloc       objc_malloc
#  define NGMallocAtomic objc_atomic_malloc
#  define NGFree         objc_free
#  define NGRealloc      objc_realloc
#else
#  define NGMalloc       malloc
#  define NGMallocAtomic malloc
#  define NGFree         free
#  define NGRealloc      realloc
#endif

#endif /* __NGExtensions_NGMemoryAllocation_H__ */
