// $Id: NGMerging.h,v 1.1.1.1 2002/05/22 17:27:16 helge Exp $

#ifndef __NGExtensions_NGMerging_H__
#define __NGExtensions_NGMerging_H__

#import <Foundation/NSObject.h>
#import <Foundation/NSZone.h>
#import <Foundation/NSDictionary.h>
#import <Foundation/NSArray.h>

@interface NSObject(NGMerging)

- (BOOL)canMergeWithObject:(id)_object;
- (id)mergeWithObject:(id)_object zone:(NSZone *)_zone;
- (id)mergeWithObject:(id)_object;

@end

/*
  dictionaries merge only with other dictionaries
*/
@interface NSDictionary(NGMerging)

- (id)mergeWithDictionary:(NSDictionary *)_object zone:(NSZone *)_zone;

@end

/*
  arrays merge with any objects responding to -objectEnumerator
*/
@interface NSArray(NGMerging)

- (id)mergeWithArray:(NSArray *)_object zone:(NSZone *)_zone;
- (id)mergeWithEnumeration:(NSEnumerator *)_object zone:(NSZone *)_zone;

@end

#endif /* __NGExtensions_NGMerging_H__ */
