// $Id: NGObjCRuntime.h,v 1.1.1.1 2002/05/22 17:27:16 helge Exp $

#ifndef __NGExtensions_NGObjCRuntime_H__
#define __NGExtensions_NGObjCRuntime_H__

#import <Foundation/NSObject.h>

@class NSString, NSArray, NSEnumerator;

@interface NSObject(NGObjCRuntime)

/* retrieving additional class info */

+ (unsigned)instanceSize;

/* adding methods to a class */

+ (void)addMethods:(SEL)_selector, ...;
+ (void)addClassMethods:(SEL)_selector, ...;

+ (NSEnumerator *)methodNameEnumerator;
+ (NSEnumerator *)hierachyMethodNameEnumerator;

/* making a subclass of a class */

+ (Class)subclass:(NSString *)_className ivars:(NSString *)_name1,...;

/* instance variables */

+ (NSArray *)instanceVariableNames;
+ (NSArray *)allInstanceVariableNames;
+ (BOOL)hasInstanceVariableWithName:(NSString *)_ivarName;
+ (NSString *)signatureOfInstanceVariableWithName:(NSString *)_ivarName;
+ (unsigned)offsetOfInstanceVariableWithName:(NSString *)_ivarName;

@end

#endif /* __NGExtensions_NGObjCRuntime_H__ */
