/* 
   NSData+misc.m

   Copyright (C) 2002 SKYRIX Software AG, Helge Hess
   All rights reserved.

   Author: Helge Hess (helge.hess@skyrix.com)

   This file is part of the SKYRiX Core Framework

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/
// $Id: NSData+misc.m,v 1.2 2002/12/27 09:43:40 helge Exp $

#import "common.h"
#import "NSData+misc.h"

@implementation NSData(misc)

- (BOOL)hasPrefix:(NSData *)_data {
  return [self hasPrefixBytes:[_data bytes] length:[_data length]];
}

- (BOOL)hasPrefixBytes:(const void *)_bytes length:(unsigned)_len {
  if (_len > [self length])
    return NO;
  else {
    const unsigned char *ownBytes = [self bytes];
    register int i;

    for (i = 0; i < _len; i++) {
      if (((unsigned char *)_bytes)[i] != ownBytes[i])
        return NO;
    }
    return YES;
  }
}

@end

void __link_NSData_misc() {
  __link_NSData_misc();
}
