/* 
   NSMethodSignature+misc.m

   Copyright (C) 2002 SKYRIX Software AG, Helge Hess
   All rights reserved.

   Author: Helge Hess (helge.hess@skyrix.com)

   This file is part of the SKYRiX Core Framework

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/
// $Id: NSMethodSignature+misc.m,v 1.2 2002/12/27 09:43:40 helge Exp $

#import "common.h"
#import "NSMethodSignature+misc.h"

@implementation NSMethodSignature(misc)

#if NeXT_Foundation_LIBRARY
- (NSString *)objCTypes {
  return [NSString stringWithCString:self->_types];
}
#else
- (NSString *)objCTypes {
  char buf[256], *bufPos = buf;
  int  argCount = [self numberOfArguments];
  char *pos1    = NULL, *pos2 = NULL;
  
  // return type
  pos1 = (char *)[self types];
  pos2 = (char *)objc_skip_typespec(pos1);
  strncpy(bufPos, pos1, pos2 - pos1);
  bufPos += pos2 - pos1;
  //*bufPos = '\0';
  pos1 = (char *)objc_skip_offset(pos2);

  // arguments
  {
    register int i;

    for (i = 0; i < argCount; i++) {
      pos2 = (char *)objc_skip_typespec(pos1); // forward to offset
      strncpy(bufPos, pos1, pos2 - pos1);
      bufPos += pos2 - pos1;
      //*bufPos = '\0';
      pos1 = (char *)objc_skip_offset(pos2);   // forward to next type
    }
  }
  *bufPos = '\0';

  return [NSString stringWithCString:buf];
}
#endif

@end /* NSMethodSignature(misc) */

void __link_NSMethodSignature_misc() {
  __link_NSMethodSignature_misc();
}
