// $Id: NSProcessInfo+misc.h,v 1.1.1.1 2002/05/22 17:27:16 helge Exp $

#ifndef __NSProcessInfo_misc_H__
#define __NSProcessInfo_misc_H__

#import <Foundation/NSProcessInfo.h>

@interface NSProcessInfo(misc)

/* arguments */

- (NSArray *)argumentsWithoutDefaults;

/* create temp file name */

- (NSString *)temporaryFileName:(NSString *)_prefix;
- (NSString *)temporaryFileName;

/* return process-id (pid on Unix) */
- (id)processId;

/* return path to proc directory for this process */
- (NSString *)procDirectoryPathForProcess;

/* returns contents of /proc/pid/status */
- (NSDictionary *)procStatusDictionary;

/* returns contents of /proc/pid/stat mapped as in 'man 5 proc' */
- (NSDictionary *)procStatDictionary;

/* wrappers */
- (unsigned int)virtualMemorySize;
- (unsigned int)residentSetSize;
- (unsigned int)residentSetSizeLimit;

@end

#endif /* __NSProcessInfo_misc_H__ */
