// $Id: NSRunLoop+FileObjects.h,v 1.1 2003/04/01 15:50:43 helge Exp $
// Created by Helge Hess on Mon Mar 11 2002.

#ifndef __FoundationExt_NSRunLoop_FileObjects__
#define __FoundationExt_NSRunLoop_FileObjects__

#import <Foundation/NSRunLoop.h>

typedef enum {
    NSPosixNoActivity = 0,
    NSPosixReadableActivity = 1,
    NSPosixWritableActivity = 2,
    NSPosixExceptionalActivity = 4
} NSPosixFileActivities;

extern NSString *NSFileObjectBecameActiveNotificationName;

@interface NSRunLoop(FileObjects)

/* Monitoring file objects */

- (void)addFileObject:(id)_fileObject
  activities:(unsigned int)_activities
  forMode:(NSString *)_mode;
  
- (void)removeFileObject:(id)_fileObject
  forMode:(NSString *)_mode;

@end

@interface NSObject(RunloopFileObject)

- (BOOL)isOpen;
- (int)fileDescriptor;

@end

#endif /* __FoundationExt_NSRunLoop_FileObjects__ */
