/* 
   NSSet+enumerator.h

   Copyright (C) 2002 SKYRIX Software AG, Helge Hess
   All rights reserved.

   Author: Jan Reichmann (jan.reichmann@skyrix.com)

   This file is part of the SKYRiX Core Framework

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/
// $Id: NSSet+enumerator.h,v 1.2 2002/12/27 09:43:59 helge Exp $

#ifndef __NGExtensions_NSSet_enumerator_H__
#define __NGExtensions_NSSet_enumerator_H__

#import <Foundation/NSSet.h>

@interface NSSet(enumerator)

- (id)initWithObjectsFromEnumerator:(NSEnumerator *)_enumerator;

- (NSArray *)mappedArrayUsingSelector:(SEL)_selector;
- (NSArray *)mappedArrayUsingSelector:(SEL)_selector withObject:(id)_object;
- (NSSet *)mappedSetUsingSelector:(SEL)_selector;
- (NSSet *)mappedSetUsingSelector:(SEL)_selector withObject:(id)_object;

@end

@interface NSMutableSet(enumerator);

- (id)initWithObjectsFromEnumerator:(NSEnumerator *)_enumerator;

@end

#endif /* __NGExtensions_NSSet_enumerator_H__ */
