// $Id: NGLdapAttribute.h,v 1.1.1.1 2002/05/22 17:27:17 helge Exp $

#ifndef __NGLdapAttribute_H__
#define __NGLdapAttribute_H__

#import <Foundation/NSObject.h>

@class NSString, NSArray, NSData, NSEnumerator;

@interface NGLdapAttribute : NSObject < NSCopying >
{
  NSString *name;
  NSArray  *values;
  BOOL     didChange;
}

- (id)initWithAttributeName:(NSString *)_name;
- (id)initWithAttributeName:(NSString *)_name values:(NSArray *)_values;

/* attribute name operations */

- (NSString *)attributeName;

+ (NSString *)baseNameOfAttributeName:(NSString *)_attrName;
- (NSString *)attributeBaseName;

+ (NSArray *)subtypesOfAttributeName:(NSString *)_attrName;
- (NSArray *)subtypes;
- (BOOL)hasSubtype:(NSString *)_subtype;
- (NSString *)langSubtype;

/* values */

- (unsigned)count;

- (void)addValue:(NSData *)_value;
- (NSArray *)allValues;
- (NSEnumerator *)valueEnumerator;

- (void)addStringValue:(NSString *)_value;
- (NSArray *)allStringValues;
- (NSEnumerator *)stringValueEnumerator;
- (NSString *)stringValueAtIndex:(unsigned)_idx;

@end

#endif /* __NGLdapAttribute_H__ */
