// $Id: NGLdapDataSource.h,v 1.1.1.1 2002/05/22 17:27:17 helge Exp $

#ifndef __NGLdapDataSource_H__
#define __NGLdapDataSource_H__

#import <EOControl/EODataSource.h>

@class EOFetchSpecification;
@class NGLdapConnection;

/*
  supported keys:
    
    any LDAP attribute name
    
  supported fetch hints:

    NSFetchKeys  - array of NSString's denoting the keys to fetch
    NSFetchScope - [NSFetchScopeBase|NSFetchScopeOneLevel|NSFetchScopeSubTree]
*/

@interface NGLdapDataSource : EODataSource
{
  NGLdapConnection     *ldap;
  EOFetchSpecification *fspec;
  NSString             *searchBase;
}

- (id)initWithLdapConnection:(NGLdapConnection *)_con searchBase:(NSString *)_dn;

/* accessors */

- (void)setFetchSpecification:(EOFetchSpecification *)_fspec;
- (EOFetchSpecification *)fetchSpecification;

/* operations */

- (NSArray *)fetchObjects;

- (NSString *)searchBase;

@end /* NGLdapDataSource */

#endif /* __NGLdapDataSource_H__ */
