// $Id: NGLdapEntry.h,v 1.1.1.1 2002/05/22 17:27:17 helge Exp $

#ifndef __NGLdapEntry_H__
#define __NGLdapEntry_H__

#import <Foundation/NSObject.h>

@class NSString, NSDictionary, NSArray;
@class NGLdapAttribute;

@interface NGLdapEntry : NSObject < NSCopying >
{
  NSString *dn;
  NSArray  *attributes;
}

- (id)initWithDN:(NSString *)_dn attributes:(NSArray *)_attrs;

/* distinguished name */

- (NSString *)dn;
- (NSString *)rdn; /* relative dn */

/* class */

- (NSArray *)objectClasses;

/* attributes */

- (NGLdapAttribute *)attributeWithName:(NSString *)_name;
- (NGLdapAttribute *)attributeWithName:(NSString *)_name
  language:(NSString *)_language;

- (NSArray *)attributeNames;
- (NSDictionary *)attributes;
- (unsigned)count;

/* LDIF */

- (NSString *)ldif;

@end

#endif /* __NGLdapEntry_H__ */
