// $Id: NGLdapModification.m,v 1.2 2003/01/07 11:34:54 helge Exp $

#include "NGLdapModification.h"
#include "NGLdapAttribute.h"
#include "common.h"

@implementation NGLdapModification

+ (id)addModification:(NGLdapAttribute *)_attribute {
  return [[[self alloc] initWithOperation:NGLdapAddAttribute
                        attribute:_attribute] autorelease];
}
+ (id)replaceModification:(NGLdapAttribute *)_attribute {
  return [[[self alloc] initWithOperation:NGLdapReplaceAttribute
                        attribute:_attribute] autorelease];
}
+ (id)deleteModification:(NGLdapAttribute *)_attribute {
  return [[[self alloc] initWithOperation:NGLdapDeleteAttribute
                        attribute:_attribute] autorelease];
}

- (id)initWithOperation:(int)_op attribute:(NGLdapAttribute *)_attribute {
  self->operation = _op;
  self->attribute = [_attribute retain];
  return self;
}

- (void)dealloc {
  [self->attribute release];
  [super dealloc];
}

- (int)operation {
  return self->operation;
}

- (NGLdapAttribute *)attribute {
  return self->attribute;
}

- (NSString *)description {
  return [NSString stringWithFormat:@"%@ : self->attribute %@ operation %d",
                   [super description], self->attribute, self->operation];
}

@end /* NGLdapModification */
