// $Id: NGLdapURL.h,v 1.1.1.1 2002/05/22 17:27:17 helge Exp $

#ifndef __NGLdapURL_H__
#define __NGLdapURL_H__

#import <Foundation/NSObject.h> // required by gstep-base
#import <Foundation/NSURL.h>

@class NSString, NSArray, NSHost, NSEnumerator;
@class NGLdapConnection, NGLdapEntry;

// ldap://hostport/dn[?attributes[?scope[?filter]]]

@interface NGLdapURL : NSURL < NSCopying >
{
  NSString *host;
  int      port;
  NSString *base;
  int      scope;
  NSString *filter;
  NSArray  *attributes;
}

+ (id)ldapURLWithString:(NSString *)_url;
- (id)initWithString:(NSString *)_url; // designated initializer

/* accessors */

- (NSString *)hostName;
- (NSHost *)host;

- (int)port;
- (NSString *)baseDN;
- (int)scope;
- (NSString *)searchFilter;
- (NSArray *)attributes;

/* query */

- (NGLdapConnection *)openConnection;
- (NSEnumerator *)fetchEntries;
- (NGLdapEntry *)fetchEntry;

/* url */

- (NSString *)urlString;

@end

#endif /* __NGLdapURL_H__ */
