// $Id: NGImap4Message.h,v 1.5 2002/12/23 14:39:53 helge Exp $

#ifndef __Database_NGImap4_NGImap4Message_H__
#define __Database_NGImap4_NGImap4Message_H__

#import <Foundation/NSObject.h>
#import <NGMime/NGPart.h>
#import <NGImap4/NGImap4Support.h>

@class NSArray, NSMutableDictionary;
@class NGHashMap;
@class NGImap4Context, NGImap4Folder;

@interface NGImap4Message : NSObject
{
@protected
  NGHashMap      *headers;
  unsigned       uid;
  int            size;
  NSArray        *flags;

  id<NGMimePart> message;
  id<NGMimePart> bodyStructure;
  NSData         *rawData;

  NGImap4Context *context;
  NGImap4Folder  *folder; // not retained

  NSURL          *url;

  NSMutableDictionary *bodyStructureContent;
}

+ (id)messageWithUid:(unsigned)_uid folder:(NGImap4Folder *)_folder
  context:(NGImap4Context *)_ctx;

+ (id)messageWithUid:(unsigned)_uid headers:(NGHashMap *)_header
  size:(unsigned)_size flags:(NSArray *)_flags folder:(NGImap4Folder *)_folder
  context:(NGImap4Context *)_ctx;

- (id)initWithUid:(unsigned)_uid folder:(NGImap4Folder *)_folder
  context:(NGImap4Context *)_ctx;

- (id)initWithUid:(unsigned)_uid headers:(NGHashMap *)_header
  size:(unsigned)_size flags:(NSArray *)_flags folder:(NGImap4Folder *)_folder
  context:(NGImap4Context *)_ctx;

// accessors
- (NSException *)lastException;
- (void)resetLastException;
- (NGHashMap *)headers;
- (int)size;
- (unsigned)uid;
- (NSArray *)flags;

- (NSData *)contentsOfPart:(NSString *)_part;
- (id<NGMimePart>)bodyStructure;
- (id<NGMimePart>)message;
- (NSData *)rawData;

- (NGImap4Folder *)folder;
- (NGImap4Context *)context;

- (void)addFlag:(NSString *)_flag;
- (void)removeFlag:(NSString *)_flag;

- (BOOL)isRead;
- (void)markRead;
- (void)markUnread;

- (BOOL)isFlagged;
- (void)markFlagged;
- (void)markUnFlagged;

- (BOOL)isAnswered;
- (void)markAnswered;
- (void)markNotAnswered;

/* equality */

- (BOOL)isEqual:(id)_obj;
- (BOOL)isEqualToNGImap4Message:(NGImap4Message *)_messages;

- (NSURL *)url;

@end

#endif /* __Database_NGImap4_NGImap4Message_H__ */
