// $Id: NGImap4ServerRoot.h,v 1.1.1.1 2002/05/22 17:27:18 helge Exp $
#ifndef __Networking_NGImap4_NGImap4ServerRoot_H__
#define __Networking_NGImap4_NGImap4ServerRoot_H__

#import  <Foundation/Foundation.h>
#include <NGMime/NGPart.h>
#include <NGImap4/NGImap4Support.h>

@class NSArray, NSString, NSMutableArray, NSNumber;
@class NGHashMap, NGImap4Context, EOQualifier;

@interface NGImap4ServerRoot : NSObject <NGImap4Folder>
{
@private  
  NSString       *name;
  NGImap4Context *context;
  NSArray        *subFolders;
}

+ (id)serverRootWithContext:(NGImap4Context *)_context;

- (id)initServerRootWithContext:(NGImap4Context *)_context;

- (NSException *)lastException;
- (void)resetLastException;

- (BOOL)isEqual:(id)_obj;
- (BOOL)isEqualToServerRoot:(NGImap4ServerRoot *)_root;

- (NGImap4Context *)context;
- (NGImap4Folder *)parentFolder;

- (NSString *)name;
- (NSString *)absoluteName;
- (BOOL)renameTo:(NSString *)_name;
- (BOOL)isInTrash;

- (NSArray *)messageFlags;
- (NSArray *)messages;
- (NSArray *)messagesForQualifier:(EOQualifier *)_qualifier;
- (NSArray *)messagesForQualifier:(EOQualifier *)_qualifier maxCount:(int)_cnt;
- (BOOL)deleteMessages:(NSArray *)_messages;
- (BOOL)deleteAllMessages;
- (BOOL)moveMessages:(NSArray *)_messages toFolder:(NGImap4Folder *)_folder;
- (BOOL)copyMessages:(NSArray *)_messages toFolder:(NGImap4Folder *)_folder;
- (BOOL)appendMessage:(NSData *)_msg;
- (BOOL)hasNewMessagesSearchRecursiv:(BOOL)_recursiv;
- (BOOL)hasUnseenMessagesSearchRecursiv:(BOOL)_recursiv;
- (BOOL)addFlag:(NSString *)_flag toMessages:(NSArray *)_messages;
- (BOOL)removeFlag:(NSString *)_flag fromMessages:(NSArray *)_messages;

- (NSArray *)subFolders;
- (NGImap4Folder *)subFolderWithName:(NSString *)_name
  caseInsensitive:(BOOL)_caseIns;
- (BOOL)deleteSubFolder:(NGImap4Folder *)_folder;
- (BOOL)createSubFolderWithName:(NSString *)_name;
- (BOOL)copySubFolder:(NGImap4Folder *)_f to:(NGImap4Folder *)_folder;
- (BOOL)moveSubFolder:(NGImap4Folder *)_f to:(NGImap4Folder *)_folder;

- (BOOL)isReadOnly;
- (BOOL)noselect;
- (BOOL)noinferiors;

- (int)exists;
- (int)recent;
- (int)unseen;
- (void)status;
- (void)select;
- (void)expunge;

- (void)resetFolder;
- (void)resetSubFolders;
- (void)resetStatus;

- (void)resetSync;

@end

#endif /* __Networking_NGImap4_NGImap4ServerRoot_H__ */
