// $Id: NGMailAddressParser.h,v 1.1.1.1 2002/05/22 17:27:18 helge Exp $

#ifndef __NGMail_NGMailAddressParser_H__
#define __NGMail_NGMailAddressParser_H__

#import <Foundation/NSObject.h>

@class NSData, NSString, NSArray;
@class NGMailAddressList;

/*
  use RFC 822
*/

@interface NGMailAddressParser : NSObject
{
@private
  unsigned char *data;
  int           dataPos;
  int           errorPos;  
  int           maxLength;
}

+ (id)mailAddressParserWithString:(NSString *)_string;
+ (id)mailAddressParserWithData:(NSData *)_data;
+ (id)mailAddressParserWithCString:(char *)_cString;
- (id)initWithCString:(const char *)_cString length:(int unsigned)_length;

// parsing

- (id)parse; // returns NGMailAddressList/NGMailAddress or nil on error
- (NSArray *)parseAddressList;

// error information

- (int)errorPosition;

@end

#endif /* __NGMail_NGMailAddressParser_H__ */
