// $Id: NGMimeMessage.h,v 1.1.1.1 2002/05/22 17:27:17 helge Exp $

#ifndef __NGMail_NGMimeMessage_H__
#define __NGMail_NGMimeMessage_H__

#import <Foundation/NSObject.h>
#include <NGMime/NGPart.h>

@class NGHashMap;

/*
  NGMimeMessage represents a RFC822 message with MIME extensions.
*/

@interface NGMimeMessage : NSObject < NGMimePart >
{
@protected
  NGHashMap  *header;
  id         body;
  NGMimeType *mimeType;
}

+ (id)messageWithHeader:(NGHashMap *)_headers;
- (id)initWithHeader:(NGHashMap *)_headers; // designated initializer

// NGPart

- (NSEnumerator *)valuesOfHeaderFieldWithName:(NSString *)_name;
- (NSEnumerator *)headerFieldNames;

- (void)setBody:(id)_body;
- (id)body;

// NGMimePart

- (NGMimeType *)contentType;
- (NSString *)contentId;
- (NSArray *)contentLanguage;
- (NSString *)contentMd5;
- (NSString *)encoding;
- (NSString *)contentDescription;

@end

#endif /* __NGMail_NGMimeMessage_H__ */
