// $Id: NGMimeMessageParser.h,v 1.4 2003/02/17 17:32:09 jan Exp $

#ifndef __NGMime_NGMimeMessageParser_H__
#define __NGMime_NGMimeMessageParser_H__

#include <NGMime/NGMimePartParser.h>

/*
  NGMimeMessageParser
  
  This class is used to parse RFC 822 MIME messages. It's the correct
  class to parse email messages.
  
  Usage:
    data = [NSData dataWithContentsOfMappedFile:@"MyMail.eml"];
    parser = [[NGMimeMessageParser alloc] init];
    part = [parser parsePartFromData:data];
    NSLog(@"Subject: %@", [part valuesOfHeaderFieldWithName:@"subject"]);
    [parser release];
*/

@interface NGMimeMessageParser : NGMimePartParser
@end

@interface NSData(MimeQPHeaderFieldDecoding)

/*
  This method decodes header fields which contain quoted
  printable information.
  Note that the return value can be both, an NSString or
  an NSData depending on the case.

  Sample: 
   attachment; filename="langerp=?iso-8859-15?q?=FC=E4=F6=20Name=F6=F6=F6=201234456=2Exls?="
*/
- (id)decodeQuotedPrintableValueOfMIMEHeaderField:(NSString *)_field;

@end

@interface NGMimeRfc822BodyParser : NGMimeBodyParser
@end


#endif /* __NGMime_NGMimeMessageParser_H__ */

