// $Id: NGPop3Support.h,v 1.1.1.1 2002/05/22 17:27:18 helge Exp $

#ifndef __NGMail_NGPop3Support_H__
#define __NGMail_NGPop3Support_H__

#import <Foundation/NSObject.h>
#include <NGMail/NGPop3Client.h>

@class NSString;

@interface NGPop3Response : NSObject
{
@protected
  NSString *line;
}

+ (id)responseWithLine:(NSString *)_line;

// accessors

- (BOOL)isPositive;
- (NSString *)line;

@end

@interface NGPop3MessageInfo : NSObject
{
@protected
  NGPop3Client *client;
  int          messageNumber;
  int          messageSize;
}

+ (id)infoForMessage:(int)_num size:(int)_size client:(NGPop3Client *)_client;

// accessors

- (int)messageNumber;
- (int)size;
- (NGPop3Client *)pop3Client;

@end

#import <Foundation/NSEnumerator.h>

@interface NGPop3MailDropEnumerator : NSEnumerator
{
@protected
  NSEnumerator *msgInfos;
}

- (id)initWithMessageInfoEnumerator:(NSEnumerator *)_infos;
- (id)nextObject;

@end

@interface NGPop3Exception : NSException
@end

@interface NGPop3StateException : NGPop3Exception
{
@protected
  NGPop3State requiredState;
}

- (id)initWithClient:(NGPop3Client *)_client requiredState:(NGPop3State)_state;
- (NGPop3State)requiredState;

@end

#endif /* __NGMail_NGPop3Support_H__ */
