// $Id: NGMimeBodyGenerator.h,v 1.2 2003/01/27 18:22:59 jan Exp $

#ifndef __NGMimeGenerator_NGMimeBodyGenerator_H__
#define __NGMimeGenerator_NGMimeBodyGenerator_H__

#import <Foundation/NSObject.h>
#import <NGMime/NGPart.h>
#import <NGMime/NGMimeGeneratorProtocols.h>

@class NSData, NSString, NSArray, NGMutableHashMap;
@class NGMimeMultipartBodyGenerator, NGMimeMultipartBody;

@interface NGMimeBodyGenerator : NSObject <NGMimeBodyGenerator>
{
  BOOL useMimeData;
}
- (NSData *)generateBodyOfPart:(id<NGMimePart>)_part
  additionalHeaders:(NGMutableHashMap *)_addHeaders
  delegate:(id)_delegate;

- (NSData *)encodeData:(NSData *)_data
  forPart:(id<NGMimePart>)_part
  additionalHeaders:(NGMutableHashMap *)_addHeaders;

- (BOOL)useMimeData;
- (void)setUseMimeData:(BOOL)_b;
@end

@interface NGMimeTextBodyGenerator : NGMimeBodyGenerator
@end

@interface NGMimeRfc822BodyGenerator : NGMimeBodyGenerator

- (id<NGMimePartGenerator>)generatorForPart:(id<NGMimePart>)_part;

@end

@interface NGMimeMultipartBodyGenerator : NGMimeBodyGenerator

+ (NSString *)boundaryPrefix;

- (NSString *)multipartBodyGenerator:(NGMimeMultipartBodyGenerator *)_gen
  prefixForPart:(id<NGMimePart>)_part
  mimeMultipart:(NGMimeMultipartBody *)_body;
  
- (NSString *)multipartBodyGenerator:(NGMimeMultipartBodyGenerator *)_gen
  suffixForPart:(id<NGMimePart>)_part
  mimeMultipart:(NGMimeMultipartBody *)_body;
  
- (id<NGMimePartGenerator>)multipartBodyGenerator:(NGMimeBodyGenerator *)_gen
  generatorForPart:(id<NGMimePart>)_part;

- (NSData *)buildDataWithBoundary:(NSString *)_boundary
  partsData:(NSArray *)_parts;

- (NSString *)buildBoundaryForPart:(id<NGMimePart>)_part data:(NSArray *)_data
  additionalHeaders:(NGMutableHashMap *)_addHeaders; 
  
@end

#endif // __NGMimeGenerator_NGMimeBodyGenerator_H__
