// $Id: NGMimeBodyParser.h,v 1.2 2003/02/17 17:32:09 jan Exp $

#ifndef __NGMime_NGMimeBodyParser_H__
#define __NGMime_NGMimeBodyParser_H__

#import <Foundation/NSObject.h>
#include <NGMime/NGPart.h>

@class NSData;

@protocol NGMimeBodyParser < NSObject >

- (id)parseBodyOfPart:(id<NGMimePart>)_part
  data:(NSData *)_data
  delegate:(id)_delegate;

@end

@interface NGMimeBodyParser : NSObject < NGMimeBodyParser >
@end

@interface NGMimeTextBodyParser : NGMimeBodyParser
@end

@class NGMimePartParser;
@class NGMimeMultipartBody;

/*
  A multipart body is a part body that contains body-parts separated
  by boundary lines.
*/
@interface NGMimeMultipartBodyParser : NGMimeBodyParser

- (BOOL)parseBody:(NGMimeMultipartBody *)_body
  ofMultipart:(id<NGMimePart>)_part
  data:(NSData *)_data
  delegate:(id)_d;

- (id<NGMimePart>)parseBodyPartWithData:(NSData *)_rawData
  inMultipart:(id<NGMimePart>)_multipart
  parser:(NGMimePartParser *)_parser; // usually a NGMimeBodyPartParser

@end

@interface NSObject(NGMimeMultipartBodyParserDelegate)

- (BOOL)multipartBodyParser:(NGMimeMultipartBodyParser *)_parser
  immediatlyParseBodyOfMultipart:(id<NGMimePart>)_part
  data:(NSData *)_data;

- (void)multipartBodyParser:(NGMimeMultipartBodyParser *)_parser
  foundPrefix:(NSData *)_prefix
  inMultipart:(id<NGMimePart>)_part;

- (void)multipartBodyParser:(NGMimeMultipartBodyParser *)_parser
  foundSuffix:(NSData *)_suffix
  inMultipart:(id<NGMimePart>)_part;

- (NGMimePartParser *)multipartBodyParser:(NGMimeMultipartBodyParser *)_parser
  parserForEntity:(NSData *)_data
  inMultipart:(id<NGMimePart>)_part;

@end

#endif /* __NGMime_NGMimeBodyParser_H__ */
