// $Id: NGMimeBodyParser.m,v 1.9 2003/02/17 17:32:09 jan Exp $

#include "NGMimeBodyParser.h"
#include "NGMimeBodyPartParser.h"
#include "NGMimeMultipartBody.h"
#include "common.h"

@implementation NGMimeBodyParser

+ (int)version {
  return 2;
}

- (id)parseBodyOfPart:(id<NGMimePart>)_part
  data:(NSData *)_data
  delegate:(id)_d
{
  return _data;
}

@end /* NGMimeBodyParser */

@implementation NGMimeTextBodyParser

+ (int)version {
  return 2;
}
+ (void)initialize {
  NSAssert2([super version] == 2,
            @"invalid superclass (%@) version %i !",
            NSStringFromClass([self superclass]), [super version]);
}

- (id)parseBodyOfPart:(id<NGMimePart>)_part data:(NSData *)_data delegate:(id)_d {
  NSStringEncoding encoding;
  NSString         *charset = nil;
  id ctype;
  id body;
  
  if (_data == nil) return nil;
  
  ctype = [_part contentType];
  if (![ctype isKindOfClass:[NGMimeType class]])
    ctype = [NGMimeType mimeType:[ctype stringValue]];
  
  charset = [[ctype valueOfParameter:NGMimeParameterTextCharset]
                    lowercaseString];
  
  encoding = [NGMimeType stringEncodingForCharset:charset];
  
  body = [[NSString alloc]
                    initWithData:_data
                    encoding:encoding];
  return AUTORELEASE(body);
}

@end /* NGMimeTextBodyParser */

