// $Id: NGMimeBodyPart.h,v 1.2 2002/07/08 16:03:49 helge Exp $

#ifndef __NGMime_NGMimeBodyPart_H__
#define __NGMime_NGMimeBodyPart_H__

#import <Foundation/NSObject.h>
#include <NGMime/NGPart.h>

@class NGHashMap;

/*
  NGMimeBodyPart is a part that is contained in a multipart body.
*/
@interface NGMimeBodyPart : NSObject < NGMimePart >
{
@protected
  NGHashMap *header;
  id        body;
}

+ (id)bodyPartWithHeader:(NGHashMap *)_headers;
- (id)initWithHeader:(NGHashMap *)_headers; // designated initializer

/* NGPart */

- (NSEnumerator *)valuesOfHeaderFieldWithName:(NSString *)_name;
- (NSEnumerator *)headerFieldNames;

- (void)setBody:(id)_body;
- (id)body;

/* NGMimePart */

- (NGMimeType *)contentType;
- (NSString *)contentId;
- (NSArray *)contentLanguage;
- (NSString *)contentMd5;
- (NSString *)encoding;
- (NSString *)contentDescription;

@end

#endif /* __NGMime_NGMimeBodyPart_H__ */
