// $Id: NGMimeGeneratorProtocols.h,v 1.2 2003/01/28 10:40:40 jan Exp $

#ifndef __NGMimeGenerator_NGMimeGeneratorProtocols_H__
#define __NGMimeGenerator_NGMimeGeneratorProtocols_H__

#import <Foundation/NSObject.h>
#import <NGMime/NGPart.h>

@class NSData, NGMutableHashMap;

@protocol NGMimePartGenerator <NSObject>

/* generate mime from part and store it in _file */
- (NSString *)generateMimeFromPartToFile:(id<NGMimePart>)_part;

- (NSData *)generateMimeFromPart:(id<NGMimePart>)_part;
- (void)setDelegate:(id)_delegate;
- (id)delegate;
- (void)setUseMimeData:(BOOL)_useMimeData;

@end

@protocol NGMimeBodyGenerator < NSObject >

- (NSData *)generateBodyOfPart:(id<NGMimePart>)_part
  additionalHeaders:(NGMutableHashMap *)_addHeaders
  delegate:(id)_delegate;

- (NSData *)encodeData:(NSData *)_data
  forPart:(id<NGMimePart>)_part
  additionalHeaders:(NGMutableHashMap *)_addHeaders;

/* use mime data objects to store mime objects on disk instead in memory */

- (void)setUseMimeData:(BOOL)_useMimeData;
@end

@protocol NGMimeHeaderFieldGenerator < NSObject >

- (NSData *)generateDataForHeaderFieldNamed:(NSString *)_headerField
  value:(id)_value;

@end

#endif // __NGMimeGenerator_NGMimeGeneratorProtocols_H__
