// $Id: NGMimeHeaderFieldGenerator.h,v 1.2 2002/05/31 14:13:41 jan41 Exp $

#ifndef __NGMime_NGHeaderFieldGenerator_H__
#define __NGMime_NGHeaderFieldGenerator_H__

#import <Foundation/NSObject.h>
#import <NGMime/NGMimeGeneratorProtocols.h>

@class NSString, NSData, NSMutableDictionary;

@interface NGMimeHeaderFieldGenerator : NSObject <NGMimeHeaderFieldGenerator>

+ (id)headerFieldGenerator;

- (NSData *)generateDataForHeaderFieldNamed:(NSString *)_headerField
  value:(id)_value;

@end

@interface NGMimeContentTypeHeaderFieldGenerator : NGMimeHeaderFieldGenerator
@end

@interface NGMimeContentLengthHeaderFieldGenerator : NGMimeHeaderFieldGenerator
@end

@interface NGMimeRFC822DateHeaderFieldGenerator : NGMimeHeaderFieldGenerator
@end

@interface NGMimeContentDispositionHeaderFieldGenerator :
                                                     NGMimeHeaderFieldGenerator
@end

@interface NGMimeStringHeaderFieldGenerator : NGMimeHeaderFieldGenerator
@end

@interface NGMimeAddressHeaderFieldGenerator : NGMimeHeaderFieldGenerator
@end

@interface NGMimeHeaderFieldGeneratorSet : NSObject <NGMimeHeaderFieldGenerator>
{
@protected
  NSMutableDictionary            *fieldNameToGenerate;
  id<NGMimeHeaderFieldGenerator> defaultGenerator;
}

+ (id)headerFieldGeneratorSet;
+ (id)defaultRfc822HeaderFieldGeneratorSet;

- (id)init;
- (id)initWithDefaultGenerator:(id<NGMimeHeaderFieldGenerator>)_gen;

// accessors

- (void)setGenerator:(id<NGMimeHeaderFieldGenerator>)_gen
  forField:(NSString *)_name;

- (void)setDefaultGenerator:(id<NGMimeHeaderFieldGenerator>)_gen;
- (id<NGMimeHeaderFieldGenerator>)_gen;

// operation

- (NSData *)generateDataForHeaderFieldNamed:(NSString *)_headerField
  value:(id)_value;

@end


#endif // __NGMime_NGHeaderFieldGenerator_H__

