// $Id: NGMimeHeaderFields.h,v 1.2 2003/01/07 11:38:27 helge Exp $

#ifndef __NGMime_NGMimeHeaderFields_H__
#define __NGMime_NGMimeHeaderFields_H__

#import <Foundation/NSObject.h>
#include <NGMime/NGMimeDecls.h>

@class NSString, NSDictionary;

/*
  NGMimeContentDispositionHeaderField
  
  This class is a special value object for holding (and parsing)
  the content of a content-disposition MIME header field (primarily
  used for attachments).
*/

NGMime_EXPORT NSString *NGMimeContentDispositionInlineType;
NGMime_EXPORT NSString *NGMimeContentDispositionAttachmentType;
NGMime_EXPORT NSString *NGMimeContentDispositionFormType;

@interface NGMimeContentDispositionHeaderField : NSObject
{
@protected
  NSString     *type;
  NSDictionary *parameters;
}

- (id)initWithString:(NSString *)_value;

/* accessors */

- (NSString *)type;

/* parameters */

- (NSString *)name;
- (NSString *)filename;
- (NSString *)valueOfParameterWithName:(NSString *)_name;

- (NSString *)stringValue;
- (NSString *)parametersAsString;
- (BOOL)valueNeedsQuotes:(NSString *)_parameterValue;

@end

#endif /* __NGMime_NGMimeHeaderFields_H__ */
