// $Id: NGMimeType.h,v 1.2 2002/07/08 15:57:50 helge Exp $

#ifndef __NGMime_NGMimeType_H__
#define __NGMime_NGMimeType_H__

#import <Foundation/NSObject.h>
#import <Foundation/NSString.h>
#include <NGMime/NGMimeDecls.h>

@class NSDictionary, NSString, NSEnumerator;

// type & parameter constants

NGMime_EXPORT NSString *NGMimeTypeText;
NGMime_EXPORT NSString *NGMimeTypeAudio;
NGMime_EXPORT NSString *NGMimeTypeVideo;
NGMime_EXPORT NSString *NGMimeTypeImage;
NGMime_EXPORT NSString *NGMimeTypeApplication;
NGMime_EXPORT NSString *NGMimeTypeMultipart;
NGMime_EXPORT NSString *NGMimeTypeMessage;

NGMime_EXPORT NSString *NGMimeParameterTextCharset;

/*
  NGMimeType is a class cluster
*/

@interface NGMimeType : NSObject < NSCoding, NSCopying >
{
}

+ (id)mimeType:(NSString *)_type subType:(NSString *)_subType;
+ (id)mimeType:(NSString *)_type subType:(NSString *)_subType
  parameters:(NSDictionary *)_parameters;

+ (id)mimeType:(NSString *)_stringValue;

+ (NSStringEncoding)stringEncodingForCharset:(NSString *)_s;

// type

- (NSString *)type;
- (NSString *)subType;
- (BOOL)isCompositeType;

// comparing types

- (BOOL)isEqualToMimeType:(NGMimeType *)_type;
- (BOOL)isEqual:(id)_other;
- (BOOL)hasSameGeneralType:(NGMimeType *)_other; // only the 'type' must match
- (BOOL)hasSameType:(NGMimeType *)_other;        // parameters need not match
- (BOOL)doesMatchType:(NGMimeType *)_other;      // interpretes wildcards

// parameters

- (NSEnumerator *)parameterNames;
- (id)valueOfParameter:(NSString *)_parameterName;

// representations

- (NSDictionary *)parametersAsDictionary;
- (NSString *)parametersAsString;
- (BOOL)valueNeedsQuotes:(NSString *)_parameterValue;

- (NSString *)stringValue;

@end

#endif /* __NGMime_NGMimeType_H__ */
