// $Id: NGPart.h,v 1.2 2003/01/13 15:17:20 helge Exp $

#ifndef __NGMime_NGPart_H__
#define __NGMime_NGPart_H__

#import <Foundation/NSObject.h>
#import <Foundation/NSData.h>

/*
  NGPart / NGMimePart
  
  Represents a MIME part, that is, a data block with associated header fields.
*/

@class NSEnumerator, NSString, NSArray;
@class NGMimeType;

@protocol NGPart < NSObject >

- (NSEnumerator *)valuesOfHeaderFieldWithName:(NSString *)_name;
- (NSEnumerator *)headerFieldNames;

- (void)setBody:(id)_body;
- (id)body;

@end

@protocol NGMimePart < NGPart >

- (NGMimeType *)contentType;   // the content-type
- (NSString *)contentId;       // get the Content-ID of this part
- (NSArray *)contentLanguage;  // get the language tags from Content-Language
- (NSString *)contentMd5;      // get the Content-MD5 digest of this part
- (NSString *)encoding;        // get the transfer encoding of this part

@end

@interface NSData(DataPart) < NGMimePart >
@end

#endif /* __NGMime_NGPart_H__ */
