// $Id: NGPart.m,v 1.2 2003/01/13 18:49:57 jan Exp $

#include "NGPart.h"
#include "NGMimeType.h"
#include "common.h"
#include <NGMime/NGMimePartParser.h>

@implementation NSData(DataPart)

/* NGPart */

- (NSEnumerator *)valuesOfHeaderFieldWithName:(NSString *)_name {
  id value = nil;

  static NGMimeHeaderNames *Fields = NULL;

  if (!Fields)
    Fields = (NGMimeHeaderNames *)[NGMimePartParser headerFieldNames];
  
  if ([_name isEqualToString:Fields->contentLength])
    value = [NSNumber numberWithUnsignedInt:[self length]];
  else if ([_name isEqualToString:Fields->contentType])
    value = [self contentType];
  else if ([_name isEqualToString:@"content-id"])
    value = [self contentId];
  else if ([_name isEqualToString:@"content-m5"])
    value = [self contentMd5];
  else if ([_name isEqualToString:@"content-language"])
    value = [self contentLanguage];

  if (value)
    return [[NSArray arrayWithObject:value] objectEnumerator];
  
  return nil;
}
- (NSEnumerator *)headerFieldNames {
  return nil;
}

- (void)setBody:(id)_body {
  [self doesNotRecognizeSelector:_cmd];
}
- (id)body {
  return self;
}

/* NGMimePart */

- (NGMimeType *)contentType {
  static NGMimeType *defType = nil;
  if (defType == nil)
    defType = [[NGMimeType mimeType:@"application/octet"] retain];
  return defType;
}
- (NSString *)contentId {
  return nil;
}

- (NSArray *)contentLanguage {
  return nil;
}
- (NSString *)contentMd5 {
  return nil;
}
- (NSString *)encoding {
  return nil;
}

@end /* NSData(DataPart) */

@implementation NSMutableData(DataPart)

- (void)setBody:(id)_body {
  [self setData:_body];
}

@end /* NSMutableData(DataPart) */

void __link_NGPart(void) {
  __link_NGPart();
}
