/* 
   NGStringTextStream.h

   Copyright (C) 2002 SKYRIX Software AG, Helge Hess
   All rights reserved.

   Author: Helge Hess (helge.hess@skyrix.com)

   This file is part of the SKYRiX Core Framework

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/
// $Id: NGStringTextStream.h,v 1.2 2002/12/27 09:46:48 helge Exp $

#ifndef __NGStreams_NGStringTextStream_H__
#define __NGStreams_NGStringTextStream_H__

#include <NGStreams/NGTextStream.h>
#include <NGStreams/NGTextStreamProtocols.h>

@interface NGStringTextStream : NGTextStream
{
@private
  NSString *string; // retained
  unsigned index;   // position
  BOOL     isMutable;
}

+ (id)textStreamWithString:(NSString *)_string;
- (id)initWithString:(NSString *)_string;

// accessors

- (NSString *)string;

// operations

- (BOOL)close; // releases string

// NGTextInputStream, NGExtendedTextInputStream

- (unichar)readCharacter;

- (NSString *)readLineAsString; // inefficient implementation

// NGTextOutputStream, NGExtendedTextOutputStream

// throws
//   NGReadOnlyStreamException when the stream is not writeable
//   NGStreamNotOpenException  when the stream is not open
- (BOOL)writeCharacter:(unichar)_character;

// throws
//   NGReadOnlyStreamException when the stream is not writeable
//   NGStreamNotOpenException  when the stream is not open
- (BOOL)writeString:(NSString *)_string;

- (BOOL)flush;

@end

#endif /* __NGStreams_NGStringTextStream_H__ */
