// $Id: NGTerminalSupport.m,v 1.1.1.1 2002/05/22 17:27:23 helge Exp $

#include "NGTerminalSupport.h"
#include "NGFileStream.h"
#include "NGFilterStream.h"
#include "NGCTextStream.h"
#include "NGDescriptorFunctions.h"

@implementation NGStream(NGTerminalSupport)

- (BOOL)isAssociatedWithTerminalDevice {
  return NO;
}

- (NSString *)nameOfAssociatedTerminalDevice {
  return nil;
}

@end

@implementation NGFileStream(NGTerminalSupport)

- (BOOL)isAssociatedWithTerminalDevice {
#if defined(WIN32)
  return NO;
#else
  return [self isOpen] ? NGDescriptorIsAtty(self->fd) : NO;
#endif
}

- (NSString *)nameOfAssociatedTerminalDevice {
#if defined(WIN32)
  return nil;
#else
  return [self isOpen] ? NGDescriptorGetTtyName(self->fd) : nil;
#endif
}

@end

@implementation NGFilterStream(NGTerminalSupport)

- (BOOL)isAssociatedWithTerminalDevice {
  id src = [self source];
  
  return [src respondsToSelector:_cmd]
    ? [src isAssociatedWithTerminalDevice]
    : NO;
}

- (NSString *)nameOfAssociatedTerminalDevice {
  id src = [self source];
  
  return [src respondsToSelector:_cmd]
    ? [src nameOfAssociatedTerminalDevice]
    : NO;
}

@end

@implementation NGTextStream(NGTerminalSupport)

- (BOOL)isAssociatedWithTerminalDevice {
  return NO;
}
- (NSString *)nameOfAssociatedTerminalDevice {
  return nil;
}

@end

@implementation NGCTextStream(NGTerminalSupport)

- (BOOL)isAssociatedWithTerminalDevice {
  id src = [self source];
  
  return [src respondsToSelector:_cmd]
    ? [src isAssociatedWithTerminalDevice]
    : NO;
}

- (NSString *)nameOfAssociatedTerminalDevice {
  id src = [self source];
  
  return [src respondsToSelector:_cmd]
    ? [src nameOfAssociatedTerminalDevice]
    : NO;
}

@end

void __link_NGStreams_NGTerminalSupport(void) {
  __link_NGStreams_NGTerminalSupport();
}
