/* 
   common.h

   Copyright (C) 2002 SKYRIX Software AG, Helge Hess
   All rights reserved.

   Author: Helge Hess (helge.hess@skyrix.com)

   This file is part of the SKYRiX Core Framework

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose and without fee is hereby granted, provided
   that the above copyright notice appear in all copies and that both that
   copyright notice and this permission notice appear in supporting
   documentation.

   We disclaim all warranties with regard to this software, including all
   implied warranties of merchantability and fitness, in no event shall
   we be liable for any special, indirect or consequential damages or any
   damages whatsoever resulting from loss of use, data or profits, whether in
   an action of contract, negligence or other tortious action, arising out of
   or in connection with the use or performance of this software.
*/
// $Id: common.h,v 1.3 2003/01/07 11:36:47 helge Exp $

#ifndef __NGStreams_common_H__
#define __NGStreams_common_H__

// common include files

#import  <Foundation/Foundation.h>

// configuration

#include "config.h"

#if defined(WIN32)
#  include <windows.h>
#  include <winsock.h>
#endif

#if LIB_FOUNDATION_BOEHM_GC
#  include <gc.h>
#endif

#ifdef GNU_RUNTIME
#  include <objc/objc-api.h>
#  include <objc/objc.h>
#  include <objc/encoding.h>
#endif

#if NeXT_Foundation_LIBRARY || APPLE_Foundation_LIBRARY
#  import <FoundationExt/objc-runtime.h>
#  import <FoundationExt/DefaultScannerHandler.h>
#  import <FoundationExt/PrintfFormatScanner.h>
#  import <FoundationExt/GeneralExceptions.h>
#  import <FoundationExt/MissingMethods.h>
#  import <FoundationExt/NSException.h>
#  import <FoundationExt/NSObjectMacros.h>
#else
#  include <extensions/exceptions/GeneralExceptions.h>
#endif

#if !LIB_FOUNDATION_LIBRARY && !NeXT_Foundation_LIBRARY
#  define NSWillBecomeMultiThreadedNotification NSBecomingMultiThreaded
#endif

#ifndef ASSIGN
#  define ASSIGN(object, value) \
       ({id __object = (id)object;    \
         id __value = (id)value;      \
         if (__value != __object) { if (__value) [__value retain]; \
          if (__object) [__object release]; \
          object = __value;}})
#endif

#include <NGExtensions/NGExtensions.h>

/* system config */

#if !defined(__CYGWIN32__)
#  ifdef HAVE_WINDOWS_H
#    include <windows.h>
#  endif
#  ifdef HAVE_WINSOCK_H
#    include <winsock.h>
#  endif
#endif

#ifdef HAVE_STRING_H
#  include <string.h>
#endif
#ifdef HAVE_STRINGS_H
#  include <strings.h>
#endif

#if HAVE_SYS_TYPES_H
#  include <sys/types.h>
#endif

#ifndef __MINGW32__
#  include <netinet/in.h>
#endif

#ifdef HAVE_SYS_SOCKET_H
#  include <sys/socket.h>
#endif
#ifdef HAVE_NETDB_H
#  include <netdb.h>
#endif

#if !defined(WIN32) || defined(__CYGWIN32__)
#  include <arpa/inet.h>
#  include <sys/un.h>
#endif

#ifndef AF_LOCAL
#  define AF_LOCAL AF_UNIX
#endif

#if !defined(SHUT_RD)
#  define SHUT_RD   0
#endif
#if !defined(SHUT_WR)
#  define SHUT_WR   1
#endif
#if !defined(SHUT_RDWR)
#  define SHUT_RDWR 2
#endif

// local common's

#include "NGStreamExceptions.h"

#endif /* __NGStreams_common_H__ */
