// $Id: iCalAlarm.m,v 1.1 2003/02/12 17:23:25 helge Exp $

#include "iCalAlarm.h"
#include "common.h"

@implementation iCalAlarm

- (void)dealloc {
  [self->trigger release];
  [self->comment release];
  [self->action  release];
  [self->attach  release];
  [super dealloc];
}

/* accessors */

- (void)setTrigger:(id)_value {
  ASSIGN(self->trigger, _value);
}
- (id)trigger {
  return self->trigger;
}

- (void)setAttach:(id)_value {
  ASSIGN(self->attach, _value);
}
- (id)attach {
  return self->attach;
}

- (void)setComment:(NSString *)_value {
  ASSIGNCOPY(self->comment, _value);
}
- (NSString *)comment {
  return self->comment;
}

- (void)setAction:(NSString *)_value {
  ASSIGNCOPY(self->action, _value);
}
- (NSString *)action {
  return self->action;
}

/* descriptions */

- (NSString *)description {
  NSMutableString *ms;

  ms = [NSMutableString stringWithCapacity:128];
  [ms appendFormat:@"<0x%08X[%@]:", self, NSStringFromClass([self class])];

  if (self->action)
    [ms appendFormat:@" action=%@", self->action];
  if (self->comment)
    [ms appendFormat:@" comment=%@", self->comment];
  if (self->trigger)
    [ms appendFormat:@" trigger=%@", self->trigger];
  
  [ms appendString:@">"];
  return ms;
}

@end /* iCalAlarm */
