// $Id: iCalEntityObject.h,v 1.2 2003/03/13 09:21:11 helge Exp $

#ifndef __NGiCal_iCalEntityObject_H__
#define __NGiCal_iCalEntityObject_H__

#include <NGiCal/iCalObject.h>

/*
  iCalEntityObject
  
  This is a common base class for tasks and appointments which share a lot of
  attributes.
*/

@class NSCalendarDate, NSMutableArray, NSString, NSArray;
@class iCalPerson;

@interface iCalEntityObject : iCalObject
{
  NSString       *uid;
  NSString       *summary;
  NSTimeInterval timestamp;
  NSCalendarDate *created;
  NSCalendarDate *lastModified;
  NSCalendarDate *startDate;
  NSString       *accessClass;
  NSString       *priority;
  NSMutableArray *alarms;
  iCalPerson     *organizer;
  NSMutableArray *attendees;
  NSString       *comment;
  NSString       *sequence;
  NSString       *location;
}

/* accessors */

- (NSString *)uid;
- (NSString *)summary;
- (NSString *)location;
- (NSString *)comment;
- (NSCalendarDate *)timeStampAsDate;
- (NSCalendarDate *)startDate;
- (NSCalendarDate *)lastModified;
- (NSCalendarDate *)created;
- (NSString *)accessClass;
- (NSString *)priority;
- (NSString *)sequence;

- (iCalPerson *)organizer;
- (NSArray *)attendees;
- (NSArray *)alarms;
- (BOOL)hasAlarms;

@end

#endif /* __NGiCal_iCalEntityObject_H__ */
