// $Id: iCalEntityObject.m,v 1.1 2003/03/13 09:18:06 helge Exp $

#include "iCalEntityObject.h"
#include "iCalPerson.h"
#include "common.h"


@implementation iCalEntityObject

- (void)dealloc {
  [self->location     release];
  [self->sequence     release];
  [self->startDate    release];
  [self->comment      release];
  [self->uid          release];
  [self->summary      release];
  [self->created      release];
  [self->lastModified release];
  [self->startDate    release];
  [self->accessClass  release];
  [self->priority     release];
  [self->alarms       release];
  [self->organizer    release];
  [self->attendees    release];
  [super dealloc];
}

/* accessors */

- (void)setUid:(NSString *)_value {
  if (self->uid != _value) {
    [self->uid autorelease];
    self->uid = [_value retain];
  }
}
- (NSString *)uid {
  return self->uid;
}

- (void)setSummary:(NSString *)_value {
  if (self->summary != _value) {
    [self->summary autorelease];
    self->summary = [_value retain];
  }
}
- (NSString *)summary {
  return self->summary;
}

- (void)setLocation:(NSString *)_value {
  if (self->location != _value) {
    [self->location autorelease];
    self->location = [_value retain];
  }
}
- (NSString *)location {
  return self->location;
}

- (void)setComment:(NSString *)_value {
  if (self->comment != _value) {
    [self->comment autorelease];
    self->comment = [_value retain];
  }
}
- (NSString *)comment {
  return self->comment;
}

- (void)setAccessClass:(NSString *)_value {
  if (self->accessClass != _value) {
    [self->accessClass autorelease];
    self->accessClass = [_value retain];
  }
}
- (NSString *)accessClass {
  return self->accessClass;
}
- (void)setPriority:(NSString *)_value {
  if (self->priority != _value) {
    [self->priority autorelease];
    self->priority = [_value retain];
  }
}
- (NSString *)priority {
  return self->priority;
}

- (void)setSequence:(NSString *)_value {
  if (self->sequence != _value) {
    [self->sequence autorelease];
    self->sequence = [_value retain];
  }
}
- (NSString *)sequence {
  return self->sequence;
}

- (void)setCreated:(NSCalendarDate *)_value {
  if (self->created != _value) {
    [self->created autorelease];
    self->created = [_value retain];
  }
}
- (NSCalendarDate *)created {
  return self->created;
}
- (void)setLastModified:(NSCalendarDate *)_value {
  if (self->lastModified != _value) {
    [self->lastModified autorelease];
    self->lastModified = [_value retain];
  }
}
- (NSCalendarDate *)lastModified {
  return self->lastModified;
}

- (void)setTimeStampAsDate:(NSCalendarDate *)_date {
#warning too be completed
}
- (NSCalendarDate *)timeStampAsDate {
  return [NSDate dateWithTimeIntervalSince1970:self->timestamp];
}

- (void)setStartDate:(NSCalendarDate *)_date {
  if (self->startDate != _date) {
    [self->startDate autorelease];
    self->startDate = [_date retain];
  }
}
- (NSCalendarDate *)startDate {
  return self->startDate;
}

- (void)setOrganizer:(iCalPerson *)_organizer {
  if (self->organizer != _organizer) {
    [self->organizer autorelease];
    self->organizer = [_organizer retain];
  }
}
- (iCalPerson *)organizer {
  return self->organizer;
}

- (void)addToAttendees:(iCalPerson *)_person {
  if (_person == nil) return;
  if (self->attendees == nil)
    self->attendees = [[NSMutableArray alloc] initWithCapacity:4];
  [self->attendees addObject:_person];
}
- (NSArray *)attendees {
  return self->attendees;
}

- (void)addToAlarms:(id)_alarm {
  if (_alarm == nil) return;
  if (self->alarms == nil)
    self->alarms = [[NSMutableArray alloc] initWithCapacity:1];
  [self->alarms addObject:_alarm];
}
- (BOOL)hasAlarms {
  return [self->alarms count] > 0 ? YES : NO;
}
- (NSArray *)alarms {
  return self->alarms;
}

@end /* iCalEntityObject */
