// $Id: iCalEvent.m,v 1.1 2003/02/12 17:23:27 helge Exp $

#include "iCalEvent.h"
#include "iCalPerson.h"
#include "common.h"

@implementation iCalEvent

- (void)dealloc {
  [self->endDate   release];
  [super dealloc];
}

/* accessors */

- (void)setEndDate:(NSCalendarDate *)_date {
  if (self->endDate != _date) {
    [self->endDate autorelease];
    self->endDate = [_date retain];
  }
}
- (NSCalendarDate *)endDate {
  return self->endDate;
}

- (void)setTransp:(NSString *)_transp {
  /* ignore transp ... (used by Evo 'TRANSP:OPAQUE') */
}

- (void)setDuration:(NSString *)_value {
#warning too be completed
}
- (NSString *)duration {
#warning too be completed
  return nil;
}

/* ical typing */

- (NSString *)entityName {
  return @"vevent";
}

/* descriptions */

- (NSString *)description {
  NSMutableString *ms;

  ms = [NSMutableString stringWithCapacity:128];
  [ms appendFormat:@"<0x%08X[%@]:", self, NSStringFromClass([self class])];

  if (self->uid)       [ms appendFormat:@" uid=%@", self->uid];
  if (self->startDate) [ms appendFormat:@" from=%@", self->startDate];
  if (self->endDate)   [ms appendFormat:@" to=%@", self->endDate];
  if (self->summary)   [ms appendFormat:@" summary=%@", self->summary];
  
  if (self->organizer)
    [ms appendFormat:@" organizer=%@", self->organizer];
  if (self->attendees)
    [ms appendFormat:@" attendees=%@", self->attendees];
  
  if ([self hasAlarms])
    [ms appendFormat:@" alarms=%@", self->alarms];
  
  [ms appendString:@">"];
  return ms;
}

@end /* iCalEvent */
