// $Id: iCalFreeBusy.m,v 1.1 2003/02/12 17:23:28 helge Exp $

#include "iCalFreeBusy.h"
#include "iCalPerson.h"
#include "common.h"

@implementation iCalFreeBusy

- (void)dealloc {
  [self->entries   release];
  [self->organizer release];
  [self->startDate release];
  [self->endDate   release];
  [self->url       release];
  [super dealloc];
}

/* accessors */

- (void)setUrl:(NSString *)_url {
  ASSIGN(self->url, _url);
}
- (NSString *)url {
  return self->url;
}

- (void)setStartDate:(NSCalendarDate *)_date {
  ASSIGN(self->startDate, _date);
}
- (NSCalendarDate *)startDate {
  return self->startDate;
}

- (void)setEndDate:(NSCalendarDate *)_date {
  ASSIGN(self->endDate, _date);
}
- (NSCalendarDate *)endDate {
  return self->endDate;
}

- (void)setOrganizer:(iCalPerson *)_organizer {
  ASSIGN(self->organizer, _organizer);
}
- (iCalPerson *)organizer {
  return self->organizer;
}

- (void)addToEntries:(id)_obj {
  if (_obj == nil) return;
  if (self->entries == nil)
    self->entries = [[NSMutableArray alloc] initWithCapacity:1];
  [self->entries addObject:_obj];
}

/* ical typing */

- (NSString *)entityName {
  return @"vfreebusy";
}

/* descriptions */

- (NSString *)description {
  NSMutableString *ms;

  ms = [NSMutableString stringWithCapacity:128];
  [ms appendFormat:@"<0x%08X[%@]:", self, NSStringFromClass([self class])];

  if (self->startDate) [ms appendFormat:@" from=%@", self->startDate];
  if (self->endDate)   [ms appendFormat:@" to=%@", self->endDate];
  
  if (self->organizer)
    [ms appendFormat:@" organizer=%@", self->organizer];
  
  if ([self->entries count] > 0)
    [ms appendFormat:@" %@", self->entries];
  
  [ms appendString:@">"];
  return ms;
}

@end /* iCalFreeBusy */
