// $Id: iCalPerson.m,v 1.1 2003/02/12 17:23:29 helge Exp $

#include "iCalPerson.h"
#include "common.h"

@implementation iCalPerson

- (void)dealloc {
  [self->rsvp     release];
  [self->partStat release];
  [self->role     release];
  [self->xuid     release];
  [self->email release];
  [self->cn    release];
  [super dealloc];
}

/* accessors */

- (void)setCn:(NSString *)_s {
  ASSIGNCOPY(self->cn, _s);
}
- (NSString *)cn {
  return self->cn;
}

- (void)setEmail:(NSString *)_s {
  ASSIGNCOPY(self->email, _s);
}
- (NSString *)email {
  return self->email;
}

- (void)setRsvp:(NSString *)_s {
  ASSIGNCOPY(self->rsvp, _s);
}
- (NSString *)rsvp {
  return self->rsvp;
}

- (void)setXuid:(NSString *)_s {
  ASSIGNCOPY(self->xuid, _s);
}
- (NSString *)xuid {
  return self->xuid;
}

- (void)setRole:(NSString *)_s {
  ASSIGNCOPY(self->role, _s);
}
- (NSString *)role {
  return self->role;
}

- (void)setPartStat:(NSString *)_s {
  ASSIGNCOPY(self->partStat, _s);
}
- (NSString *)partStat {
  return self->partStat;
}

/* descriptions */

- (NSString *)description {
  NSMutableString *ms;

  ms = [NSMutableString stringWithCapacity:128];
  [ms appendFormat:@"<0x%08X[%@]:", self, NSStringFromClass([self class])];

  if (self->cn)       [ms appendFormat:@" cn=%@",     self->cn];
  if (self->email)    [ms appendFormat:@" email=%@",  self->email];
  if (self->role)     [ms appendFormat:@" role=%@",   self->role];
  if (self->xuid)     [ms appendFormat:@" uid=%@",    self->xuid];
  if (self->partStat) [ms appendFormat:@" status=%@", self->partStat];
  if (self->rsvp)     [ms appendFormat:@" rsvp=%@",   self->rsvp];

  [ms appendString:@">"];
  return ms;
}

@end /* iCalPerson */
