// $Id: iCalToDo.m,v 1.1 2003/02/12 17:23:29 helge Exp $

#include "iCalToDo.h"
#include "common.h"

@implementation iCalToDo

- (void)dealloc {
  [self->accessClass     release];
  [self->percentComplete release];
  [self->completed release];
  [self->sequence  release];
  [self->uid       release];
  [self->summary   release];
  [self->startDate release];
  [self->due       release];
  [self->priority  release];
  [super dealloc];
}

/* accessors */

- (void)setPercentComplete:(NSString *)_value {
  ASSIGN(self->percentComplete, _value);
}
- (NSString *)percentComplete {
  return self->percentComplete;
}

- (void)setDue:(NSCalendarDate *)_date {
  ASSIGN(self->due, _date);
}
- (NSCalendarDate *)due {
  return self->due;
}

- (void)setCompleted:(NSCalendarDate *)_date {
  ASSIGN(self->completed, _date);
}
- (NSCalendarDate *)completed {
  return self->completed;
}

/* ical typing */

- (NSString *)entityName {
  return @"vtodo";
}

/* descriptions */

- (NSString *)description {
  NSMutableString *ms;

  ms = [NSMutableString stringWithCapacity:128];
  [ms appendFormat:@"<0x%08X[%@]:", self, NSStringFromClass([self class])];

  if (self->uid)       [ms appendFormat:@" uid=%@", self->uid];
  if (self->startDate) [ms appendFormat:@" start=%@", self->startDate];
  if (self->due)       [ms appendFormat:@" due=%@", self->due];
  if (self->priority)  [ms appendFormat:@" pri=%@", self->priority];

  if (self->completed) 
    [ms appendFormat:@" completed=%@", self->completed];
  if (self->percentComplete) 
    [ms appendFormat:@" complete=%@", self->percentComplete];
  if (self->accessClass) 
    [ms appendFormat:@" class=%@", self->accessClass];
  
  if (self->summary)
    [ms appendFormat:@" summary=%@", self->summary];
  
  [ms appendString:@">"];
  return ms;
}

@end /* iCalToDo */
