// $Id: httpu_notify.m,v 1.4 2003/01/30 16:51:11 helge Exp $

#import <Foundation/Foundation.h>
#include <NGStreams/NGDatagramPacket.h>
#include <NGStreams/NGDatagramSocket.h>
#include <NGStreams/NGInternetSocketAddress.h>
#include <NGStreams/NGInternetSocketDomain.h>

static void run(void) {
  NSUserDefaults *ud;
  NSString *sid;
  NSURL    *observer;
  NGDatagramSocket *socket = nil;
  NGInternetSocketAddress *address;
  NGDatagramPacket *packet;
  NSMutableString  *ms;
  NSData           *data;
  
  ud  = [NSUserDefaults standardUserDefaults];
  sid      = [ud stringForKey:@"sid"];
  observer = [NSURL URLWithString:[ud stringForKey:@"url"]];
  
  if (observer  == nil) {
    NSLog(@"missing observer ! (use -url to specify one !)");
    exit(2);
  }
  
  /* construct HTTP-over-UDP request */
  
  ms = [NSMutableString stringWithCapacity:16];
  [ms appendString:@"NOTIFY "];
  [ms appendString:[observer absoluteString]];
  [ms appendString:@" HTTP/1.1\r\n"];
  
  /* notifications without sid are "teardown's" */
  if ([sid length] > 0) {
    [ms appendString:@"Subscription-id: "];
    [ms appendString:sid];
    [ms appendString:@"\r\n"];
  }
  
  /* send packet */
  
  data    = [ms dataUsingEncoding:NSUTF8StringEncoding];
  packet  = [NGDatagramPacket packetWithData:data];
  address = [NGInternetSocketAddress addressWithPort:
                                       [[observer port] intValue]
                                     onHost:
                                       [observer host]];
  
  socket = [[NGDatagramSocket alloc] initWithDomain:
                                       [NGInternetSocketDomain domain]];
  [packet setReceiver:address];
  
  if (![socket sendPacket:packet timeout:3.0]) {
    NSLog(@"could not send packet %@ on socket %@ !");
    exit(1);
  }
}

int main(int argc, char **argv, char **env) {
  NSAutoreleasePool *pool;
  
  pool = [[NSAutoreleasePool alloc] init];
#if LIB_FOUNDATION_LIBRARY
  [NSProcessInfo initializeWithArguments:argv count:argc environment:env];
#endif
  
  run();
  
  exit(0);
  return 0;
}
