// $Id: subclassing.m,v 1.3 2003/01/07 18:51:59 helge Exp $

#import <Foundation/Foundation.h>
#import <NGExtensions/NGObjCRuntime.h>

#if NeXT_RUNTIME
#  include <FoundationExt/objc-runtime.h>
#endif
#if NeXT_Foundation_LIBRARY || COCOA_Foundation_LIBRARY
#  include <FoundationExt/NSObjectMacros.h>
#endif

static void myPrint(id self, SEL _cmd, int arg) {
  NSLog(@"self=%@, _cmd=%s, arg=%i", self, sel_get_name(_cmd), arg);
}

int main(int argc, char **argv, char **env) {
  NSAutoreleasePool *pool;
  Class c;
  id    o;
  pool = [NSAutoreleasePool new];
#if LIB_FOUNDATION_LIBRARY
  [NSProcessInfo initializeWithArguments:argv count:argc environment:env];
#endif

  NSLog(@"mt: %s", [NSWillBecomeMultiThreadedNotification cString]);

  NSLog(@"class NSObject:  size=%d", [NSObject  instanceSize]);
  NSLog(@"class NSString:  size=%d", [NSString  instanceSize]);
  NSLog(@"class NSRunLoop: size=%d", [NSRunLoop instanceSize]);

  /* subclass NSObject */
  
  c = [NSObject subclass:@"MyObject"
                ivars:@"blah", @"@", @"blub", @"c", @"blab", @"s", nil];
  
  printf("MyObject is 0x%08X\n", (unsigned)c);
  printf("MyObject name is %s\n", c->name);
  printf("MyObject super-name is %s\n", c->super_class->name);
  
  NSLog(@"MyObject: %@", c);
  o = [[c alloc] init];
  NSLog(@"MyObject-instance: %@", o);
  
  NSLog(@" instance respondsto 'myPrint': %s",
        [o respondsToSelector:@selector(myPrint:)] ? "yes" : "no");
  [c addMethods:@selector(myPrint:), @"v@:i", myPrint, nil];
  NSLog(@" instance respondsto 'myPrint': %s",
        [o respondsToSelector:@selector(myPrint:)] ? "yes" : "no");
  [o myPrint:14];

  NSLog(@" class respondsto 'myPrint': %s",
        [c respondsToSelector:@selector(myPrint:)] ? "yes" : "no");
  [c addClassMethods:@selector(myPrint:), @"v@:i", myPrint, nil];
  NSLog(@" class respondsto 'myPrint': %s",
        [c respondsToSelector:@selector(myPrint:)] ? "yes" : "no");
  [c myPrint:14];
  
  [o release]; o = nil;
  
  /* subclass NSRunLoop */
  
  c = [NSRunLoop subclass:@"MyRunLoop"
                 ivars:@"blah", @"@", @"blub", @"c", @"blab", @"s", nil];

  printf("MyRunLoop is 0x%08X\n", (unsigned int)c);
  printf("MyRunLoop name is %s\n", c->name);
  printf("MyRunLoop super-name is %s\n", c->super_class->name);
  
  NSLog(@"MyRunLoop: %@", c);
  NSLog(@"MyRunLoop-instance: %@", [[c alloc] init]);
  NSLog(@"MyRunLoop ivars: class=%@ all=%@",
        [c instanceVariableNames], [c allInstanceVariableNames]);
  NSLog(@"  signature of blub: %@",
        [c signatureOfInstanceVariableWithName:@"blub"]);
  
  [pool release];
  return 0;
}
