// $Id: test_qpdecode.m,v 1.4 2003/01/07 11:37:30 helge Exp $

/*
  check whether the quoted printable MIME decoding works ...
*/

#include "common.h"

static void test(void) {
  static unsigned char *fields[] = {
    "attachment; filename=\"Mappe langerp=?iso-8859-15?q?=FC=E4=F6=20Name=F6=F6=F6=201234456=2Exls?=\"",
    "Umlaute: =?iso-8859-15?q?=FC=E4=F6?=",
    "keine Umlaute: =?iso-8859-15?q?keine Umlaute?=",
    "=?iso-8859-15?q?keine Umlaute?=",
    "=?iso-8859-15?q?=FC=E4=F6?=",
    "",
    "hello world !",
    "??doit??",
    NULL
  };
  unsigned char *field;
  int i;
  
  for (i = 0; (field = fields[i]); i++) {
    NSData *fieldData;
    id result;
    
    NSLog(@"decoding field: '%s'", field);
    fieldData = [NSData dataWithBytes:field length:strlen(field)];
    NSLog(@"  length: %i", [fieldData length]);
    
    result = [fieldData decodeQuotedPrintableValueOfMIMEHeaderField:
			  @"content-disposition"];
    
    if (result == nil) {
      NSLog(@"  got no result for field data %@ !!!", fieldData);
    }
    else if ([result isKindOfClass:[NSData class]]) {
      NSLog(@"  got a data, length %i: %@", [result length], result);
    }
    else if ([result isKindOfClass:[NSString class]]) {
      NSLog(@"  got a string, length %i: '%@'", [result length], result);
    }
    else {
      NSLog(@"  got an unexpected object, class %@: %@",
	    NSStringFromClass([result class]), result);
    }
  }
}

int main(int argc, char **argv, char **env) {
  NSAutoreleasePool *pool;
  
  pool = [NSAutoreleasePool new];
  
#if LIB_FOUNDATION_LIBRARY  
  [NSProcessInfo initializeWithArguments:argv count:argc environment:env];
#endif
  
  test();
  
  [pool release];
  exit(0);
  /* static linking */
  [NGExtensions class];
  return 0;
}
